{============================================================================}
{==                                                                        ==}
{==                           CHEAT VIEWER Version 1.1                     ==}
{==                   Copyright (C) 1994-96 By The GodFather               ==}
{==                                                                        ==}
{============================================================================}

{$M, 8192,0,655355}

USES Dos,
     GUtils, GMemory, GList_o, GButtons, GFDialog;

CONST
  SLineSize = 20;
  Version   = 'Version 1.1';

TYPE
  PCheat      = ^TCheat;
  TCheat      = OBJECT(TObject)
     Name     : PString;
     Line     : LongInt;
     LNum     : Word;
     CONSTRUCTOR Init(aName: STRING; aLine: LongInt; aLNum: Word);
     DESTRUCTOR Done; VIRTUAL;
  END;

  PView       = ^TView;
  TView       = OBJECT(TObject)
        Data  : PString;
        CONSTRUCTOR Init(aData: STRING);
        DESTRUCTOR Done; VIRTUAL;
  END;


VAR
  UpY     : Byte;
  List    : PList;
  Database: PCollection;
  ViewList: PList;
  ViewData: PCollection;
  OldPal  : ARRAY[1..6] OF Byte;
  FileName: STRING;
  MaxLines: LongInt;
  SearchLine: STRING[SLineSize];


CONSTRUCTOR TCheat.Init(aName: STRING; aLine: LongInt; aLNum: Word);
BEGIN
  Name := NewStr(aName);
  Line := aLine;
  LNum := aLNum;
END;

DESTRUCTOR TCheat.Done;
BEGIN
  DisposeStr(Name);
END;

CONSTRUCTOR TView.Init(aData: STRING);
BEGIN
  IF aData <> ''
    THEN Data := NewStr(aData)
    ELSE Data := NIL;
END;

DESTRUCTOR TView.Done;
BEGIN
  IF Data <> NIL THEN DisposeStr(Data);
END;


FUNCTION Code(St: STRING): STRING;
VAR I: Byte;
  FUNCTION RetRes: Byte; NEAR;
  VAR A: Byte;
  BEGIN
    A := 1;
    IF Odd(I) THEN Inc(A);
    RetRes := A;
  END;
BEGIN
  FOR I := 1 TO Length(St) DO
    St[I] := Chr( Ord(St[I]) XOR (Ord(St[0])+150+RetRes));
  Code := St;
END;

PROCEDURE GoToLine(Key:Word);
VAR
  I,Len   : Byte;
  FoundIT : Boolean;
  aRecord : PCheat;
  GameName: STRING;
  OldLine : STRING[SLineSize];
BEGIN
  IF Length(SearchLine) = SLineSize THEN Exit;
  IF Key IN [97..122] THEN Dec(Key,32);
  FoundIT    := False;
  OldLine    := SearchLine;
  Len        := Length(SearchLine)+1;
  SearchLine := SearchLine + Chr(Key);
  FOR I:=0 TO Database^.Count-1 DO
  BEGIN
    aRecord  := Database^.At(I);
    GameName := AdjCase(Upper,aRecord^.Name^);
    GameName := System.Copy(GameName,1,Len);
    IF SearchLine = GameName THEN FoundIT := True;
    IF FoundIT THEN Break;
  END;
  IF NOT FoundIT THEN BEGIN SearchLine := OldLine; Exit; END;
  IF (I+1 <> List^.Position) AND FoundIT THEN
  BEGIN
    List^.Position := I+1;
    ReDrawList(List);
  END;
END;

FUNCTION GetCheatName(Position: Integer):STRING;
VAR Current: PCheat; S: STRING;
BEGIN
  Current      := Database^.At(Position-1);
  S            := Current^.Name^;
  IF S = '-= READ THIS =-'
    THEN GetCheatName := ' '+PadCenter(S,48,' ')
    ELSE GetCheatName := ' '+S;
END;

FUNCTION GetViewData(Position: Integer):STRING;
VAR Current: PView;
BEGIN
  Current     := ViewData^.At(Position-1);
  IF Current^.Data = NIL
    THEN GetViewData := ' '
    ELSE GetViewData := Current^.Data^;
END;

PROCEDURE ReadDatabase;
VAR
  CVFile: Text;
  CVData: STRING;
  S1,S2 : STRING;
  I1,I2 : Integer;
  I     : Byte;

BEGIN
  Assign(CVFile,FileName);
  {$I-}
    Reset(CVFile);
  {$I+}
  IF IOResult <> 0 THEN
  BEGIN
    Writeln('Error opening '+FileName);
    Halt(2);
  END;
  Readln(CVFile,CVData);
  IF CVData <> 'CHEAT VIEWER FILE' THEN
  BEGIN
    Writeln(FileName+' is not CHEAT VIEWER file');
    Close(CVFile);
    Halt(3);
  END;
  MaxLines := 0;
  Database := New(PCollection, Init(1,1));
  REPEAT
    Readln(CVFile,CVData);
    CVData := Code(CVData);
    IF CVData = '-=This is the end=-' THEN Break;
    S1     := ExtractWords(1,1,CVData);
    S2     := ExtractWords(3,1,CVData);
    CVData := ExtractWords(2,1,CVData);
    I1     := StrToInt(S1);
    I2     := StrToInt(S2);
    IF I1+I2 > MaxLines THEN MaxLines := I1+I2;
    FOR I := 1 TO Length(CVData) DO
      IF CVData[I] = '^' THEN CVData[I] := ' ';
    Database^.Insert(New(PCheat,Init(CVData,I1,I2)));
  UNTIL True = False;
  Close(CVFile);
END;

PROCEDURE StandartOpen(Arg: STRING; Alert: Boolean);
VAR Back,BTxt,WTxt: Byte;
BEGIN
  Back:=$5D; BTxt:=$5F; WTxt:=$5E;
  IF Alert THEN BEGIN Back:=$4C; BTxt:=$4F; WTxt:=$4E; END;
  MkWin(15,12,52,8,Back,Double1,'');
  FastWrite(35,12,BTxt,' Information ');
  WriteBetween(15,67,15,WTxt,Arg);
END;

PROCEDURE InfoBox(Arg: STRING; Alert: Boolean);
VAR OK: PButtons;
BEGIN
  StandartOpen(Arg,Alert);
  New(OK,Init(1));
  OK^.AddButton(36,18,$70,$F0,'    OK    ');
  OK^.ProcessButtons;
  Dispose(OK,Done);
  RmWin;
END;

FUNCTION PromptBox(Arg: STRING; Alert: Boolean): Boolean;
VAR OK: PButtons;
BEGIN
  StandartOpen(Arg,Alert);
  New(OK,Init(1));
  OK^.AddButton(26,18,$70,$F0,'    OK    ');
  OK^.AddButton(46,18,$70,$F0,'  Cancel  ');
  IF OK^.ProcessButtons = 1
    THEN PromptBox := True
    ELSE PromptBox := False;
  Dispose(OK,Done);
  RmWin;
END;

PROCEDURE PrintData;
CONST prnMassages : ARRAY[0..4] OF STRING[21] =
       ('Everything is OK',
        'Out of paper',
        'Off line',
        'Printer is busy',
        'Unknown printer error');
VAR P: PView; I,R: Word; OK: Boolean; Regs: Registers; S: STRING;
BEGIN
  I  := 0;
  OK := False;
  IF PrinterReady
    THEN BEGIN
         FOR I := 1 TO ViewData^.Count DO
         BEGIN
           P := ViewData^.At(I-1);
           IF P^.Data = NIL
             THEN S := #13#10
             ELSE S := P^.Data^+#13#10;
           FOR R := 1 TO Length(S) DO
           BEGIN
             Regs.AH := $00;
             Regs.DX := $00;
             Regs.AL := Ord(S[R]);
             Intr($17,Regs);
             WHILE (PrinterStatus <> prnOK)   AND
                   (PrinterStatus <> prnBusy) DO
             BEGIN
               IF NOT PromptBox(prnMassages[Ord(PrinterStatus)]+' OK to retry.',True)
                 THEN Exit;
             END;
           END;
         END;
           Regs.AH := $00;
           Regs.DX := $00;
           Regs.AL := $0C;
           Intr($17,Regs);
         END
    ELSE InfoBox('Printer is not ready',True);
END;

PROCEDURE HookViewKeys(Position:Integer; VAR Key:Word);

BEGIN
  WITH ViewList^ DO
  BEGIN
    CASE Key OF
      kbEnter,45: ViewList^.EndOfList := True;
{----------------------------------------------------------------------------}
       kbPgUp: Dec(Position, Lines-1);
       kbPgDn: Inc(Position, Lines-1);
       kbUp  : BEGIN
                 IF (Lines <= MaxY-7) THEN BEGIN Key := 0; Exit; END;
                 IF Y <> 1
                   THEN BEGIN
                          Y := 1;
                          Dec(Position, Lines-1);
                        END;
               END;
       kbDown: BEGIN
                 IF (Lines <= MaxY-7) THEN BEGIN Key := 0; Exit; END;
                 IF Y <> Lines
                   THEN BEGIN
                          Y := Lines;
                          Inc(Position, Lines-1);
                        END;
               END;
     80,80+32: PrintData;
{----------------------------------------------------------------------------}
    END;
  END;
END;

PROCEDURE ViewCheat;
VAR F: Text; I,R: Word; Cheat: PCheat; S: STRING; Max,Current: LongInt;

  PROCEDURE DisplayTermometer;
  BEGIN
    PlainWrite(41,MaxY DIV 2,AddComas(RetPercent(100,Max,Current))+'%');
    Attribute (18,MaxY DIV 2,$F0,(RetPercent(50,Max,Current)));
  END;

BEGIN
  Assign(F,FileName);
  {$I-} Reset(F); {$I+}
  IF IOResult <> 0 THEN
  BEGIN
    InfoBox('Error opening '+FileName,True);
    Exit;
  END;

  Cheat    := Database^.At(List^.Position-1);
  ViewData := New(PCollection, Init(1,1));
  Max      := Cheat^.Line+Cheat^.LNum+Database^.Count+2;
  Current  := 0;

  MkWin(13,MaxY DIV 2-4,59,6,$5D,Single1,'');
  WriteBetween(14,72,MaxY DIV 2-2,$5E,'Searching & Loading');
  FastWrite(18,MaxY DIV 2  ,$0F,Replicate(50,' '));
  PlainWrite(41,MaxY DIV 2,AddComas(RetPercent(100,Max,Current))+'%');

  FOR I := 1 TO Database^.Count+2 DO
  BEGIN
    Readln(F);
    Inc(Current);
    DisplayTermometer;
  END;

  FOR I := 1 TO Cheat^.Line-1 DO
  BEGIN
    Readln(F);
    Inc(Current);
    DisplayTermometer;
  END;

  FOR I := 1 TO Cheat^.LNum DO
  BEGIN
    Readln(F,S);

    S := Code(S);

    IF Pos(#9,S) <> 0 THEN
    REPEAT
      Insert(Replicate(8,' '),S, LastPos(#9,S) );
      IF LastPos(#9,S) <> 0 THEN Delete(S,LastPos(#9,S),1);
    UNTIL LastPos(#9,S) = 0;

    ViewData^.Insert(New(PView,Init( S ) ));
    Inc(Current);
    DisplayTermometer;
    IF Eof(F) THEN Break;
  END;
  RmWin;
  MkWin(1,5,80,MaxY-5,$5D,Special1,'');
  WriteBetween(1,80, 5,$5F,' '+Cheat^.Name^+' ');
  WriteBetween(1,80,25,$5E,' Press P to print this ');
  InitList(ViewList);
  WITH ViewList^ DO
  BEGIN
    XPos      := 2;
    YPos      := 6;
    Lines     := MaxY-6;
    BarSize   := 78;
    ListPallete[lBackAttr]  := $5A;
    ListPallete[lTopicAttr] := $5A;
    ListPallete[lBarAttr]   := $5A;
    ListPallete[lsBarAttr]  := $5A;
    MaxTopics := ViewData^.Count;
    GetString := GetViewData;
    CheckKey  := HookViewKeys;
  END;
  Close(F);
  ShowList(ViewList);
  DoneList(ViewList);
  Dispose(ViewData, Done);
  RmWin;
END;

PROCEDURE HookListKeys(Position:Integer; VAR Key:Word);
BEGIN
  IF (Key < 33 ) OR
     (Key > 126) THEN SearchLine := '';
  CASE Key OF
    33..126: GotoLine(Key);
    kbEnter: ViewCheat;
  END;
END;

PROCEDURE UpdateInfoBox(Position:Integer);
BEGIN
  WriteVScrollBar(67,6,MaxY-2,$19,Position,Database^.Count);
  FastWrite(18,MaxY-1,$19,PadLeft(SearchLine,SLineSize,#196));
END;
{$F-}

PROCEDURE TheEnd;
BEGIN
  RmWin;
  Writeln(#13#10);
  WriteBetween(1,MaxX,WhereY-1,$0E,'Thank you for using CHEAT VIEWER by The GodFather');
  SetBlink(True);
  Cursor(On);
  SetPal(OrgPal);
  Halt;
END;

PROCEDURE Initialize;
BEGIN
  MkWin(10,1,60,2,$19,Single1, '');
  WriteBetween(10,70,2,$1E,'CHEAT VIEWER '+Version+' By The GodFather');
  IF FileDialog('*.GCF',' Open Datafile ')
    THEN FileName := FileDialogName
    ELSE TheEnd;
  ReadDatabase;
  MkWin(16,5,51,MaxY-6,$19,Single1,'');
  InitList(List);
  WITH List^ DO
  BEGIN
    XPos      := 17; YPos := 6;
    BarSize   := 50;
    Lines     := MaxY-7;
    MaxTopics := Database^.Count;
    GetString := GetCheatName;
    CheckKey  := HookListKeys;
    MiscProc  := UpdateInfoBox;
  END;
  ShowList(List);
  DoneList(List);

  RmWin;
  RmWin;
END;

BEGIN
  SetPal(AltPal);
  Cursor(Off);
  SetBlink(False);
  Initialize;
  Dispose(Database, Done);
  TheEnd;
END.